// Ausgangslisten zur Übung zu Funktionstemplates

// Zuerst Dateien einbinden
#include <iostream>
#include <string>

using std::cout;
using std::endl;

// Fkt-Template zum Tauschen mit beliebigen Datentypen
template <typename T>
void Swap(T& val1, T& val2)
{
   ... // verwenden Sie Ihre Implementierung
}

// Funktionstemplate zum Sortieren von
// beliebigen Datentypen innerhalb eines Feldes
// pValues ist der Zeiger auf den Beginn des Datenfeldes
// und nNoOfValues enthält die Anzahl der Daten
template <typename T>
void Sort(T pValues, int const noOfValues)
{
   ... // verwenden Sie Ihre Implementierung
}

// Definition der Klasse für die Adressdaten
class Address
{
    std::string name; // Name
    std::string location; // Ort
public:
    Address() = default; // ctor, hat nichts zu tun
    // Adressdaten setzen
    void SetData(const char* const pN,
                 const char* const pL);
    // Überladener << Operator für Ausgabe
    friend std::ostream& operator << (std::ostream& os,
                 const Address& obj2);
};
// Definition der Memberfunktionen
// setzen der Adressdaten
void Address::SetData(const char* const pN,
                      const char* const pL)
{
    name = pN;
    location = pL;
}
// Überladener Operator << für Ausgabe
std::ostream& operator << (std::ostream& os,
                           const Address& addr)
{
    os << "Name: " << addr.name;
    os << " Ort: " << addr.location << endl;
    return os;
}

// main() Funktion
int main()
{
    // Objektfeld für Adressdaten anlegen
    constexpr auto SIZE = 4;
    Address *pAddress = new Address[SIZE];

    // Objektfeld mit Daten belegen
    pAddress[0].SetData("Karl Maier","AStadt");
    pAddress[1].SetData("Agathe Mueller","XDorf");
    pAddress[2].SetData("Xaver Lehmann","CHausen");
    pAddress[3].SetData("Berta Schmitt","FStadt");

    // unsortiertes Objektfeld ausgeben
    cout << "Unsortierte Adressen:\n";
    for (auto index=0; index<SIZE; index++)
        cout << pAddress[index];

    // Hier für die Übung die Adressen sortieren und
    // erneut ausgeben

    // Objektfeld löschen
    delete [] pAddress;
}
