#include <iostream>
#include <string>
#include <utility>
#include <vector>
#include <algorithm>

using namespace std::literals;
using std::cout;
using std::endl;

// Datentyp fuer Artikel
using dtArtikel = std::pair<unsigned long, std::string>;

// Lambda-Funktion zur Ausgabe eines Artikels
auto PrintArtikel = [] (const dtArtikel& data)
{
    cout << "Artikel-Nr: " <<data.first
         << ", Artikel: " << data.second << endl;
};

// Lagerliste
std::vector<dtArtikel> lager
{
    {10'0919, "Lego-Technik"s},
    {20'0454, "Kochtoepfe"s},
    {20'0562, "Besteck"s},
    {10'2333, "Puppen"s},
    {30'4234, "Herren-Oberbekleidung"s},
    {30'2342, "Damen-Oberbekleidung"s},
    {20'7535, "Porzellan"s},
    {10'5634, "PC Spiele"s}
};

int main()
{
    // Lagerliste ausgeben
    cout << "Lagerliste:\n";
    for_each (lager.begin(), lager.end(), PrintArtikel);
    std::vector<dtArtikel> artikelListe;

    // Liste der einzelnen Artikelgruppen zusammenstellen und ausgeben
    for (auto artikel = 10'0000UL; artikel < 40'0000UL; artikel += 10'0000UL)
    {
        cout << "\nArtikel-Gruppe " << artikel << ":\n";
        // Vorherige Artikelliste leeren
        artikelListe.clear();
        // Artikel einer Artikelgruppe umkopieren
        copy_if (lager.begin(), lager.end(),std::back_inserter(artikelListe),
                 [=] (const dtArtikel& data)
                 {
                     return (data.first>=artikel) & (data.first < (artikel+10'0000));
                 });
        // Liste der Artikelgruppe ausgeben
        for_each (artikelListe.begin(), artikelListe.end(), PrintArtikel);
    }
}
