#include <iostream>
#include <array>
#include <stdexcept>
#include "demo.h"

using std::cout;
using std::endl;

// Demo-array anlegen und initialisieren
std::array<Demo,4> demoObj {"eins","zwei","drei","vier"};

int main()
{
    // array ausgeben
    for (auto& element: demoObj)
        cout << element << ',';
    cout << endl;
    // array rueckwaerts ausgeben
    for (auto revIter = demoObj.rbegin(); revIter != demoObj.rend(); ++revIter)
        cout << *revIter << ',';
    cout << endl;
    // Zugriff auf array Elemente
    // 2. Zugriff schlaegt fehl und loest Ausnahme aus
    try
    {
        cout << "1. Element: " << demoObj.at(0) << endl;
        demoObj.at(9) = "neun";
    }
    catch (std::out_of_range& ex)
    {
        cout << "Fehler: " << ex.what() << endl;
    }
    // array mit neuen Daten fuellen
    // und ausgeben
    demoObj.fill("alles neu");
    for (auto& element: demoObj)
        cout << element << ',';
    cout << endl;
}
