// Dateien einbinden
#include <iostream>
#include <cstdlib>

using std::cout;
using std::endl;

// Definition der Klasse Stack

class Stack
{
     short stackPtr;    // Stackindex (Stackpointer)
     short size;        // Stackgrösse
     short *pData;      // Zeiger auf Stack
  public:
     Stack(const short s);
     ~Stack();
     void Push(const short val);
     short Pop();
};
// Definition der Memberfunktionen
// Konstruktor
Stack::Stack(const short s)
{
    // Falls mehr als 100 Elemente auf Stack, Ausnahme auslösen
    if (s > 100)
        throw "Max. Stackgroesse ueberschritten";
    // Feld für Stackdaten anfordern
    // Wirft eventl. bad_alloc Ausnahme
    pData = new short[s];
    // Stackparameter merken
    size = s;
    stackPtr = 0;
}
// Destruktor
Stack::~Stack()
{
    delete [] pData;
}
// Legt Datum auf dem Stack ab
void Stack::Push(const short val)
{
    // Falls Stack schon voll ist
    if (stackPtr==size)
        throw "Stack belegt";
    // Datum ablegen
    pData[stackPtr++] = val;
}
// Liest Datum vom Stack aus
short Stack::Pop()
{
    // Falls Stack leer
    if (stackPtr==0)
        throw "Stack leer";
    // Datum holen
    return pData[--stackPtr];
}

// main() Funktion
int main()
{
    // Zeiger auf short-Stack
    Stack *pStack;
    // Versuche short-Stack mit 5 Elementen anzulegen
    try
    {
        pStack = new Stack(5);
    }
    // Falls Fehler beim Anlegen des Stack aufgetreten
    // Meldung ausgeben und Programm beenden
    catch(const char *const pT)
    {
        cout << "\nFEHLER: " << pT << endl;
        exit(1);
    }
    catch(std::bad_alloc&)
    {
        cout << "Nicht genuegend Speicher!" << endl;
        exit(2);
    }
    // Stack nun komplett füllen
    // Falls Stack voll ist wird Ausnahme ausgelöst
    cout << "Fuelle Stack:\n";
    try
    {
        short index = 10;
        for (;;)
            pStack->Push(index++);
    }
    catch(const char *const pT)
    {
        cout << "FEHLER:" << pT << endl;
    }
    // Stack jetzt wieder leeren
    // Falls Stack leer wird Ausnahme ausgelöst
    cout << "Leere Stack:\n";
    try
    {
        for (;;)
            cout << pStack->Pop() << ",";
    }
    catch(const char *const pszT)
    {
        cout << "\nFEHLER:" << pszT << endl;
    }
    // Stack löschen
    delete pStack;

    // Versuche zu grossen Stack anzulegen
    cout << "Lege riesigen Stack an:\n";
    try
    {
        Stack hugeStack(1000);
    }
    catch(const char *const pT)
    {
        cout << "\nFEHLER:" << pT << endl;
        exit(1);
    }
    catch(std::bad_alloc&)
    {
        cout << "Nicht genügend Speicher!" << endl;
        exit(2);
    }
}
