#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <iterator>
#include <string>


using std::cout;
using std::endl;
using namespace std::string_literals;

int main()
{
    // Vektor mit Abflugdaten
    using fdata = std::tuple<std::string, std::string, std::string>;
    std::vector<fdata> fluege
    {
        {"10:20"s, "Hamburg"s, "EW2046"s},
        {"10:40"s, "Atlanta"s, "DL117"s},
        {"10:45"s, "Frankfurt"s, "LH133"s},
        {"10:45"s, "Rom"s, "EW2884"s},
        {"10:50"s, "Kavala"s, "EW2688"s},
        {"11:00"s, "Istanbul"s, "TK1702"s}
    };

    // Anzahl der Eurowings Fluege (EW...)
    auto anzEW = std::count_if(fluege.begin(), fluege.end(),
                               [] (const fdata& val) -> bool
                               {
                                   auto airline = std::get<2>(val);
                                   return airline.find("EW") != std::string::npos;
                               }
                               );
    cout << anzEW << " Eurowing Fluege gefunden.\n";

    // Gibt es auch Fluege vor 10:00 Uhr
    auto vor10 = std::any_of(fluege.begin(), fluege.end(),
                             [] (const fdata& val) -> bool
                             {
                                 auto zeit = std::get<0>(val);
                                 return zeit < "09:59"s;
                             }
                             );
    if (vor10)
        cout << "Einige Fluege vor 10:00 Uhr\n";
    else
        cout << "Keine Fluege vor 10:00 Uhr\n";
}
