#include <iostream>
#include <cstdlib>

using std::cout;
using std::endl;

// Stackgrösse
constexpr auto SSIZE = 10;

// Klassendefinition
class Stack
{
   // Die Eigenschaften sind private und damit
   // gegen den direkten Zugriff geschützt
   short stackPtr = 0;
   short values[SSIZE];
 public:
   // Die Memberfunktionen müssen public sein sonst
   // kann mit der Klasse nicht gearbeitet werden
   Stack();
   ~Stack();
   bool Push(short val);
   bool Pop(short& val);
};

// Definition der Memberfunktionen
// Konstruktor
Stack::Stack()
{
   cout << "Stack initialisiert!\n";
}
// Destruktor
Stack::~Stack()
{
   cout << "Hole restliche Werte vom Stack:\n";
   while (stackPtr > 0)
   {
      stackPtr--;
      cout << values[stackPtr] << ' ';
   }
   cout << "\nStack geleert!" << endl;
}
// Wert auf Stack ablegen
bool Stack::Push(short val)
{
   decltype(Push(val)) retval = false;
   // Falls Stack noch nicht voll ist
   if (stackPtr != SSIZE)
   {
      // Neuen Wert ablegen
      values[stackPtr] = val;
      stackPtr++;
      retval = true;
   }
   return retval;
}
// Wert vom Stack holen
bool Stack::Pop(short& val)
{
   decltype(Pop(val)) retval = false;
   // Falls noch Werte auf dem Stack
   if (stackPtr!=0)
   {
      // Wert vom Stack holen
      stackPtr--;
      val = values[stackPtr];
      retval = true;
   }
   return retval;
}

// main() Funktion
int main()
{
   // Stackobjekt definieren
   Stack myStack;
   // Sonstige lokale Variablen definieren
   bool retVal;
   short val;

   // Stack so lange füllen bis er voll ist
   cout << "Schiebe Werte auf Stack:\n";
   do
   {
      val = std::rand() % 100;
      retVal = myStack.Push(val);
      if (retVal)
         cout << val << ' ';
   } while (retVal);

   // 5 Werte vom Stack wieder holen
   cout << "\nLese 5 Werte vom Stack:\n";
   for (auto iIndex=0; iIndex<5; iIndex++)
   {
      myStack.Pop(val);
      cout << val << ' ';
   }
   cout << endl;
}
