#include <iostream>
#include <ctime>
#include <cstdlib>

using std::cout;
using std::endl;

// Datentyp der Messwerte
using DTYPE = unsigned short;

class Measurement
{
    DTYPE   *values;            // Zeiger auf Messwerte
    int     noOfValues;         // Anzahl der Messwerte
public:
    // ctor, reserviert Feld fuer Messwert
    Measurement(int size): noOfValues(size)
    {
        values = new DTYPE[size];
    }
    // dtor, gibt Feld fuer Messwert wieder frei
    ~Measurement()
    {
        delete [] values;
    }
    // Messwerte erzeugen
    void Start()
    {
        for (auto index=0; index<noOfValues; index++)
            values[index] = rand() % 100;
    }
    // Messwerte sowie Mittelwert ausgeben
    void PrintValues()
    {
        unsigned long sum = 0;

        cout << "Werte: ";
        for (auto index=0; index<noOfValues; index++)
        {
            cout << values[index] << ',';
            sum += values[index];
        }
        cout << "\nMittelwert: " << sum/noOfValues << endl;
    }
};

// main Funktion
int main()
{
    // Messreihe fuer 10 Messwerte erstellen
    Measurement serie(10);
    // Messung starten
    serie.Start();
    // und ausgeben
    serie.PrintValues();
}
