#include <iostream>
#include <iomanip>
#include <cstdlib>

using std::cout;
using std::endl;

// Konstantendefinitionen
constexpr auto ROWS = 5;
constexpr auto COLS = 5;

// Klassendefinition
class Grid
{
    short **ppGrid; // Zeiger auf 2-dimensionales Feld
    short rows; // Anzahl der Reihen
    short cols; // Anzahl der Spalten
public:
    Grid(short ro, short co);
    ~Grid();
    bool SetCell(short ro, short co, short v);
    void PrintIt() const;
};
// Definition der Memberfunktionen
// Konstruktor
Grid::Grid(short ro, short co)
{
    // Anzahl Reihen/Spalten merken
    rows = ro;
    cols = co;

    // Feld für Tabellenreihen-Zeiger reservieren
    ppGrid = new short*[rows];
    // Speicher für die Spalten reservieren
    for (auto index=0; index<rows; index++)
    {
        ppGrid[index] = new short[cols];
    }
}
// Destruktor
Grid::~Grid()
{
    // Alle Spaltenfelder freigeben
    for (auto index=0; index<rows; index++)
        delete [] ppGrid[index];
    // Feld mit Tabellenreihen-Zeiger freigeben
    delete [] ppGrid;
}
// Zelle in der Tabelle setzen
bool Grid::SetCell(short ro, short co, short v)
{
    bool retVal = true;
    // Reihen-/Spaltennummer abprüfen
    if ((ro<0) || (ro>=rows))
        retVal = false;
	else
	{
		 if ((co<0) || (co>=cols))
			 retVal = false;
		else
			// Zelle setzen
			ppGrid[ro][co] = v;
	}
	return retVal;
}
// Tabelle ausgeben
void Grid::PrintIt() const
{

    cout << "Tabelleninhalt\n";
    cout << "==============\n";

    for (auto rIndex=0; rIndex<rows; rIndex++)
    {
        for (auto cIndex=0; cIndex<cols; cIndex++)
            cout << std::setw(4) << ppGrid[rIndex][cIndex];
        cout << endl;
    }
}
// main() Funktion
int main()
{
    // Tabelle anlegen
    auto pGrid = new Grid(ROWS, COLS);

    // Zellen mit Zufallszahlen belegen
    for (auto rIndex=0; rIndex<ROWS; rIndex++)
        for (auto cIndex=0; cIndex<COLS; cIndex++)
            pGrid->SetCell(rIndex,cIndex,rand()%100);

    // Tabelle ausgeben
    pGrid->PrintIt();

    // Diagonale der Tabelle mit -1 belegen
    constexpr auto maxDim = (ROWS>COLS)?COLS:ROWS;
    for (auto index=0; index<maxDim; index++)
        pGrid->SetCell(index,index,-1);

    // Tabelle nochmals ausgeben
    pGrid->PrintIt();

    // Tabelle nun auch wieder löschen!
    delete pGrid;
}
