#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstdlib>

using std::cout;
using std::endl;
using std::string;
using std::ifstream;

// Konstanten
const string FILENAME = "fenster01.txt"; // Datei mit Fensterdaten

// Klassendefinition
class Window
{
    int xPos, yPos; // Position
    int width, height; // Grösse
    string *pTitle; // Titel
  public:
    // Konstruktor
    Window()
    {
        cout << "Speicher fuer Fenster reserviert.\n";
        // Immer eine gute Idee: Zeiger mit dem nullptr initialisieren
        pTitle = nullptr;
    }
    // Destruktor
    ~Window()
    {
        cout << "Speicher fuer Fenster freigegeben\n";
        // Speicher für Fenstertitel freigeben!
        delete pTitle;
    }
    void Print () const;
    bool ReadFromFile(ifstream&);
};
// Definition der Memberfunktionen
// Fensterdaten ausgeben
void Window::Print() const
{
    cout << "Fenster : \'" << *pTitle << "\'\n";
    cout << "Position: " << xPos << "," << yPos << endl;
    cout << "Groesse : " << width << "," << height << endl;
}
// Liest ein Fensterdaten aus der uebergebenen Datei ein
bool Window::ReadFromFile(ifstream& inFile)
{
    bool retVal;
    // Fensterposition
    // Fehlerhaftes Dateiende abfangen!
    inFile >> xPos >> yPos;
    if (retVal = inFile.eof(); !retVal)
	{
		// Fenstergrösse einlesen
		 inFile >> width >> height;
		// string Objekt für Fenstertitel dyn. anlegen
		 pTitle = new string;
		// Fenstertitel einlesen
		std::getline(inFile,*pTitle);
	}
    return !retVal;
}

// main() Funktion
int main()
{
    ifstream winFile; // Datei mit den Fensterdaten
    int noOfWin; // Anzahl der Fensterdaten i.d. Datei

    // Datei mit Fensterdaten öffnen
    winFile.open(FILENAME);
    if (!winFile)
    {
        cout << "Fehler beim Oeffnen der Datei " << FILENAME << endl;
        exit(1);
    }

    // Anzahl der Fensterdaten einlesen
    winFile >> noOfWin;

    // Feld für die Fensterdaten anlegen
    auto pWindow = new Window[noOfWin];

    // Nun alle Fensterdaten aus Datei einlesen
    for (auto index=0; index<noOfWin; index++)
    {
         // Fehler abfangen!
        if (auto success = pWindow[index].ReadFromFile(winFile); !success)
        {
            cout << "Fehler beim Einlesen des " << index+1 << ". Fensters!\n";
            // Anzahl der Fenster korrigieren und Schleife verlassen
            noOfWin = index;
            break;
        }
    }

    // Datei nun wieder schliessen
    winFile.close();

    // Alle Fensterdaten ausgeben
    for (auto index=0; index<noOfWin; index++)
        pWindow[index].Print();

    // Feld mit Fensterdaten löschen
    // Unbedingt die eckigen Klammern beachten!!
    delete [] pWindow;
}
