#include <iostream>
#include <fstream>
#include <cstdlib>

using namespace std;

// Dateiname
constexpr auto pszDATEI = "kunden.dat";

// main() Funktion
int main()
{
   // Definition der Kundendaten mit Initialisierung
   auto kdNummer = 123;
   auto umsatz = 12.3;
   auto tag=10,monat=5,jahr=2019;

   // Das Ausgabestream-Objekt wird innerhalb eines Blocks
   // definiert. Am Blockende wird es geloescht und damit
   // die Datei geschlossen!
   {
      // Ausgabestream-Objekt definieren und mit Datei verbinden
      ofstream outFile(pszDATEI);
      // Fehler abfangen
      if (!outFile)
      {
         cout << "Fehler beim Erstellen der Datei!\n";
         exit (1);
      }
      // Daten in Datei schreiben
      // ACHTUNG! Nach jedem Datum entweder ein Leerzeichen oder ein
      // Zeilenvorschub eingeben damit Daten nachher auch wieder eingelesen koennen
      outFile << kdNummer << " " << umsatz << endl;
      outFile << tag << " " << monat << " " << jahr << endl;
   }
   // Blockende, Datei wird geschlossen!

   // Variablen zur Kontrolle mit 0 belegen
   kdNummer = tag = monat = jahr = 0;
   umsatz = 0.0;

   // Eingabestream-Objekt definieren und jetzt mit open() mit
   // der Datei verbinden. Moeglich waere auch die Datei direkt
   // wie vorhin mit dem Stream zu verbinden
   ifstream inFile;
   inFile.open(pszDATEI);
   // Fehler abfangen!
   if (!inFile)
   {
      cout << "Fehler beim Öffnen der Datei!\n";
      exit(2);
   }
   // Daten aus Datei auslesen
   inFile >> kdNummer >> umsatz; inFile >> tag >> monat >> jahr;
   // Dateiverbindung aufheben
   inFile.close();

   // Eingelesene Daten formatiert auf Bildschirm ausgeben
   cout << "Kundendaten:\n------------\n";
   cout << "KD-Nummer : " << kdNummer << endl;
   cout << "Umsatz in TSD : " << umsatz << endl;
   cout << "Letzter Umsatz am: ";
   cout << tag << "." << monat << "." << jahr << endl;
}
