#include <iostream>
#include <ctime>
#include <cstdlib>

using std::cout;
using std::endl;

// Funktion zu Berechnung der Pruefsumme
auto Checksum(unsigned char *data, int size)
{
    // Alle Elemente im Feld Exclusive-OR
    unsigned long cs = static_cast<unsigned long>(data[0]);
    for (auto index=1; index<size; index++)
        cs ^= data[index];
    // Pruefsumme zurueckgeben
    return cs;
}

// Funktion zur Datenpruefung
bool CheckData(unsigned char *data, int size, unsigned long cs)
{
    // Alle Elemente im Feld Exclusive-OR
    unsigned long csCalc = static_cast<unsigned long>(data[0]);
    for (auto index=1; index<size; index++)
        csCalc ^= data[index];
    // Vergleich mit uebergebener Pruefsumme zurueckgeben
    return (cs==csCalc);
}

// Feldgroesse
constexpr int SIZE=10;

// main Funktion
int main()
{
    // Feld anlegen
    unsigned char array[10];

    // Zufallszahlengenerator initiailisieren
    unsigned long actTime = std::time(nullptr);
    std::srand(actTime);

    // Feld mit Zufallszahlen fuellen
    for (auto index=0; index<SIZE; index++)
        array[index] = static_cast<unsigned char>(rand() & 0xFF);

    // Pruefsumme berechnen
    auto cs = Checksum(array, SIZE);
    // Daten ueberpruefen
    if (CheckData(array, SIZE, cs) == true)
        cout << "Daten sind in Ordnung" << endl;
    else
        cout << "Daten sind fehlerhaft!" << endl;

    // Daten verfaelschen
    array[0] = ~array[0];
    // Daten erneut ueberpruefen
    if (CheckData(array, SIZE, cs) == true)
        cout << "Daten sind in Ordnung" << endl;
    else
        cout << "Daten sind fehlerhaft!" << endl;
}
