#include <iostream>
#include <string>

using std::cout;
using std::endl;
using std::string;
using namespace std::string_literals;

// Aktienkurse festlegen
std::pair<float, std::string> aktien[] {
    {47.60f,"Daimler"s},
    {141.88f,"VW"s},
    {62.30,"BMW"s},
    {31.18f,"General Motors"s}};
// Anzahl der Kurse
constexpr auto SSIZE = sizeof(aktien)/sizeof(aktien[0]);

// main() Funktion
int main()
{
    size_t index;

    // Aktienkurs ausgeben
    cout << "Aktienkurse:\n";
    cout << "-----------:\n";
    for (auto [kurs, hersteller]: aktien)
    {
        cout << "Hersteller: " << hersteller
             << ", Kurs: " << kurs << endl;
    }

    // VW Aktie um 111.11 erhöhen
    aktien[1].first += 5.0;
    cout << "** VW Aktie um 5.00 erhoeht! **\n";

    // Aktien nach Wert sortieren
    bool changed;
    do
    {
        changed = false;
        for (index=0; index<SSIZE-1; index++)
        {
            // Vergleicht primär Kurse, sekundär Hersteller
            if (aktien[index]>aktien[index+1])
            {
                auto temp = aktien[index];
                aktien[index] = aktien[index+1];
                aktien[index+1] = temp;
                changed = true;
            }
        }
    } while (changed);

    // Sortierte Kurse nach Wert ausgeben
    cout << "\nKurse nach Wert sortiert:\n";
    cout << "------------------------------------\n";
    for (auto [kurs,hersteller]: aktien)
    {
        cout << "Hersteller: " << hersteller
             << ", Kurs: " << kurs << endl;
    }
}
