#include <iostream>
#include <vector>
#include <string>
#include <algorithm>

using std::cout;
using std::endl;

using namespace std::string_literals;

int main()
{
    // Handballspieler
    std::vector<std::string> handball
    {
        "Franz Mueller"s, "Gustav Maier"s, "Uwe Lehmann"s,
        "Adrian Schmid"s, "Sabine Krause"s, "Gisela Schmid"s
    };
    // Fussballspieler
    std::vector<std::string> fussball
    {
        "Adrian Schmid"s,"Xaver Bauer"s, "Klaus Maier"s,
        "Gustav Lehmann"s, "Sabine Krause"s
    };

    // Vektor fuer Ergebnis
    std::vector<std::string> resVect;
    // Vektoren sortieren
    std::sort(handball.begin(), handball.end());
    std::sort(fussball.begin(), fussball.end());

    // Ausgabe der Personen, die nur eine Sportart betreiben
    // (Differenzmenge)
    cout << "Personen die nur Handball oder Fussball spielen:\n";
    std::set_symmetric_difference(fussball.begin(), fussball.end(),
                   handball.begin(), handball.end(),
                   std::back_inserter(resVect));
    for (const auto& elem: resVect)
        cout << elem << endl;

    // Ausgabe der Personen, die beide Sportarten betreiben
    // (Schnittmenge)
    cout << "\nPersonen die sowohl Handball als auch Fussball spielen:\n";
    resVect.clear();
    std::set_intersection(fussball.begin(), fussball.end(),
                   handball.begin(), handball.end(),
                   std::back_inserter(resVect));
    for (const auto& elem: resVect)
        cout << elem << endl;
}
