#include <iostream>
#include <iomanip>
#include <vector>
#include <algorithm>
#include <utility>

using std::cout;
using std::endl;
using namespace std::string_literals;

// Vektor mit Tankdaten
// 1. Pairelement: gefahrene Kilomenter
// 2. Pairelement: getankter Treibstoff (ltr)
using TANKDATEN = std::pair<int,int>;
std::vector<TANKDATEN> tankdaten
    {{340,25},{450,32},{240,18},{650,44}};

// Vektor mit Verbrauchsdaten
std::vector<float> verbrauch;
int main()
{
    // Verbraeuche ltr/100km berechnen
    // Die Verbraeuche werden hier mittels einer
    // Lambda-Funktion berechnet
    std::transform(tankdaten.begin(), tankdaten.end(),
                   back_inserter(verbrauch),
                   [] (const TANKDATEN& data)
                   {
                       return float(data.second) / float(data.first) * 100.0f;
                   });
    cout << "Berechnete Verbraeuche: ";
    cout << std::setprecision(3);
    for (auto elem: verbrauch)
        cout << elem << ", ";

    // Min/Max Verbrauch suchen
    // Daten mittels structured binding uebernehmen
    cout << "\nMin/Max Verbrauch: ";
    auto [vmin, vmax] = minmax_element(verbrauch.begin(), verbrauch.end());
    cout << *vmin << ", " << *vmax << endl;
}
