#include <iostream>
#include <string>

using std::cout;
using std::endl;

// Klassendefinition
class CTestCase
{
public:
    // enum der Prioritäten
    enum priority {low, medium, high, critical};
    // enum des Prüffallstatus
    enum state {defined, failed, ok};
private:
    std::string description; // Beschreibung
    unsigned int tcNumber; // Nummer
    priority prio; // Priorität
    state tcState; // Status
    inline static unsigned int number = 1; // Prüffallindex
  public:
    // ctor
    CTestCase(const std::string& desc, priority p);
    // Default copy-ctor da keine dyn. Eigenschaften vorhanden
    CTestCase(const CTestCase&) = default;
    // Default dtor
    ~CTestCase() = default;
    // Zuweisung der Priorität
    CTestCase& operator = (priority p);
    // Zuweisung des Status
    CTestCase& operator = (state s);
    // Ausgabe des Prüffalls
    void PrintIt () const;
};
// Definition der Memberfunktion
// ctor
CTestCase::CTestCase(const std::string& desc, priority p) :
    description(desc)
{
    tcNumber = number; // Nummber ablegen
    number++; // Pruffallindex erhöhen
    tcState = defined; // Status setzen
    prio = p; // Priorität ablegen
 }
// Zuweisung des Status
inline CTestCase& CTestCase::operator = (state s)
{
    tcState = s;
    return *this;
}
// Zuweisung der Priorität
inline CTestCase& CTestCase::operator = (priority p)
{
    prio = p;
    return *this;
}
// Ausgabe des Prüffalls
void CTestCase::PrintIt () const
{
    cout << "Prueffall: " << description << endl;
    cout << "Nummer: " << tcNumber << ", Prioritaet: " << prio << ", Status: ";
    switch (tcState)
    {
    case defined:
        cout << "definiert";
        break;
    case failed:
        cout << "fehlerhaft";
        break;
    case ok:
        cout << "erfolgreich";
        break;
    default:
        cout << "unbekannt";
    }
    cout << endl << endl;
}

// main() Funktion
int main()
{
    // Prüffall definieren
    CTestCase test1("Testen der Programmfunktionen", CTestCase::low);
    // und ausgeben
    test1.PrintIt();
    // Priotät umsetzen
    test1 = CTestCase::high;
    // Status auf ok setzen
    test1 = CTestCase::ok;
    // Prüffall erneut ausgeben
    test1.PrintIt();
    // Weiteren Prüffall definieren
    CTestCase test2("Stesstest", CTestCase::critical);
    // Prüffall auf failed setzen
    test2 = CTestCase::failed;
    // Prüffall ausgeben
    test2.PrintIt();
}
