#include <iostream>
#include <bitset>

using std::cout;
using std::endl;
using std::bitset;

// Bereich der Primzahlen
constexpr int MAX = 100;

// main() Funktion
int main()
{
    bitset<MAX> primes; // Bitset mit 'Primzahlen'

    // Alle Zahlen als Primzahlen markieren
    primes.set();
    // 0 und 1 sind keine Primzahlen!
    primes.reset(0);
    primes.reset(1);

    auto index = 2; // Aktuelle Primzahl ist 2
    do
    {
        // Durchsuche alle Zahlen ab der aktuellen Primzahl+1
        // und entferne diejenigen, die durch die Primzahl teilbar sind
        for (auto prim = index+1; prim<MAX; prim++)
        {
            // Wenn Zahl noch nicht entfernt wurde
            if (primes.test(prim))
            {
                // prüfe, ob Zahl durch Primzahl teilbar
                if (prim%index == 0)
                   // Wenn ja, dann ist Zahl keine Primzahl
                   primes.reset(prim);
            }
        }
        // Suche nächste noch vorhandene Zahl,
        // dies ist auch die nächste Primzahl
        if (index++; index<MAX)
        {
            do
            {
                if (primes.test(index))
                   // nächste Primzahl gefunden
                   break;
                index++;
            } while (index<MAX);
        }
    } while (index<MAX);

    // Alle gefundenen Primzahlen ausgeben
    cout << "Gefundene Primzahlen:\n";
    for (auto lcount=0, index=0; index<MAX; index++)
    {
        // Wenn Primzahl gefunden
        if (primes.test(index))
        {
            cout << index << ',';
            // Etwas Ausgabeformatierung
            lcount++;
            if ((lcount%15) == 0)
                cout << '\n';
        }
    }
    cout << endl;

    return 0;
}
