#include <iostream>
#include <iomanip>
#include <string>
#include <queue>
#include <tuple>

using std::cout;
using std::endl;
using std::string;
using std::priority_queue;

using namespace std::string_literals;
// Alias fuer Flugdaten
using flight = std::tuple<string, unsigned char, unsigned char>;

// main() Funktion
int main()
{
    // Priority-Queue definieren
    priority_queue<flight> arrivals;
    // Flugdaten ablegen
    arrivals.push({"333"s,17,38});
    arrivals.push({"111"s,10,59});
    arrivals.push({"444"s,10,38});
    arrivals.push({"222"s,9,0});

    // Alle Flüge nun ausgeben
    cout << std::setfill('0');
    while (!arrivals.empty())
    {
        // stuctured binding!
        auto [fnumber, hour, minute] = arrivals.top();
        cout << "Flug: " << fnumber << ", Ankunft: "
            << std::setw(2) << static_cast<int>(hour) << ':'
            << std::setw(2) << static_cast<int>(minute) << endl;
        arrivals.pop();
    }
}
