#include <iostream>
#include <iomanip>
#include <string>
#include <map>

using std::cout;
using std::endl;
using namespace std::string_literals;

// main() Funktion
int main()
{
    // Aktien in map ablegen
    // Schluessel: Hersteller; Datum: Aktienkurs
    std::map<std::string,float> aktien;

    // Map mit Daten füllen
    aktien["VW"s] = 12.f;
    aktien["Ford"s] = 34.45f;
    aktien["BMW"s] = 54.45f;
    aktien["Daimler Chrysler"s] = 123.50f;

    // Ausgabe der Aktienwerte mit 2 Nachkommastellen
    cout << std::fixed << std::setprecision(2);
    for (auto [hersteller, kurs]: aktien)
        cout << hersteller << " Aktie: " << kurs << " EUR\n";

    // VW Aktien um 10.00 erhöhen
    cout << "-- VW Aktie stiegt um 10.00 EUR --\n";
    aktien["VW"s] += 10.f;

    // Alle Aktien ausgeben
    for (auto [hersteller, kurs]: aktien)
        cout << hersteller << " Aktie: " << kurs << " EUR\n";

    // Element explizit hinzufügen
    cout << "-- Porsche Aktien hinzufuegen --\n";
    aktien.emplace("Porsche"s,560.0f);

    // Daimler Chrysler Aktien in Daimler umbenennen
    // Zuerst kopieren
    cout << "-- Daimler Chrysler in Daimler umbenennen --\n";
    aktien["Daimler"s] = aktien["Daimler Chrysler"];
    // und dann löschen!
    aktien.erase("Daimler Chrysler"s);

    // Alle Aktien ausgeben
    for (auto [hersteller, kurs]: aktien)
        cout << hersteller << " Aktie: " << kurs << " EUR\n";
}
