#include <iostream>
#include <algorithm>
#include <vector>
#include <tuple>
#include <iterator>
#include <string>


using std::cout;
using std::endl;
using namespace std::string_literals;

int main()
{
    // Vektor mit Abflugdaten
    using fdata = std::tuple<std::string, std::string, std::string>;
    std::vector<fdata> fluege
    {
        {"10:20"s, "Hamburg"s, "EW2046"s},
        {"10:40"s, "Atlanta"s, "DL117"s},
        {"10:45"s, "Frankfurt"s, "LH133"s},
        {"10:45"s, "Rom"s, "EW2884"s},
        {"10:50"s, "Kavala"s, "EW2688"s},
        {"11:00"s, "Istanbul"s, "TK1702"s}
    };

    // Suche ersten Flug nach 10:45
    auto iterTime = std::find_if(fluege.begin(),fluege.end(),
                              [] (const fdata& val) -> bool
                                 {
                                     return std::get<0>(val) > "10:45"s;
                                 }
                              );
    cout << "Erster Flug nach 10:45 um " << std::get<0>(*iterTime) <<": " << std::get<2>(*iterTime)
         << " nach " << std::get<1>(*iterTime) << endl;

    // Suche Flug nach Atlanta
    auto iterAtlanta = std::find(fluege.begin(), fluege.end(),
                                 std::make_tuple("10:40"s, "Atlanta"s, "DL117"s));
    // Wenn Flug gefunden, Abflugzeit auch 10:48
    if (iterAtlanta != fluege.end())
        std::get<0>(*iterAtlanta) = "10:48"s;

    // Suche ersten Flug nach 10:45
    iterTime = std::find_if(fluege.begin(),fluege.end(),
                              [] (const fdata& val) -> bool
                                 {
                                     return std::get<0>(val) > "10:45"s;
                                 }
                              );
    cout << "Erster Flug nach 10:45 um " << std::get<0>(*iterTime) <<": " << std::get<2>(*iterTime)
         << " nach " << std::get<1>(*iterTime) << endl;
}
