#include <iostream>
#include <string>

using std::cout;
using std::endl;
using std::string;

// Fensterklasse
// Alle Fenster der Klassen haben eine gemeinsame
// Titel- und Fensterfarbe aber unterschiedliche Titel
class Window
{
   inline static unsigned long titleColor = 0UL; // Titelfarbe
   inline static unsigned long winColor = 0UL; // Fensterfarbe
   string title; // Fenstertitel
 public:
   // ctor
   // Beachte: string ist ein Objekt und sollte deshalb
   // per Initialisiererliste initialisiert werden
   Window(const char* t): title(t)
   {}
   // Fenster darstellen
   void Draw() const;
   // statische Memberfunktionen zum setzen der Farben
   static void setTitleColor(unsigned char r, unsigned char g, unsigned char b);
   static void setBackColor(unsigned char r, unsigned char g, unsigned char b);
};

// Fenstereigenschaften ausgeben
void Window::Draw() const
{
   cout << std::hex << std::showbase;
   cout << "Titelfarbe: " << titleColor;
   cout << ", Titel: " << title << endl;
   cout << "Fensterfarbe: " << winColor << endl;
   cout << std::dec << std::noshowbase;
}
// Titelfarbe setzen
void Window::setTitleColor(unsigned char r, unsigned char g, unsigned char b)
{
   titleColor = (r<<16) + (g<<8) + b;
}
// Fensterfarbe setzen
void Window::setBackColor(unsigned char r, unsigned char g, unsigned char b)
{
   winColor = (r<<16) + (g<<8) + b;
}

// main() Funktion
int main()
{
   // Fenster- und Titelfarbe setzen
   Window::setBackColor(0x80,0x80,0x80);
   Window::setTitleColor(0x00,0x00,0xff);

   // Zwei Fenster definieren
   Window myWin("Mein Fenster");
   Window yourWin("Dein Fenster");
   // und deren Eigenschaften ausgeben
   myWin.Draw();
   yourWin.Draw();

   // Fensterfarbe umsetzen
   // Beachte: Es wird die Fensterfarbe für alle Fenster
   // umgesetzt da die Fensterfarbe eine statische Eigenschaft ist
   myWin.setBackColor(0x00,0x80,0xff);

   // Fenstereigenschaften erneut ausgeben
   cout << endl;
   myWin.Draw();
   yourWin.Draw();
}
