#include <iostream>

using std::cout;
using std::endl;

// Klassendefinition
class Com
{
   bool hasCom = false; // COM-Objekt besitzt noch keine Schnittstelle
   inline static bool comLocked = false; // statische Verriegelung der Schnittstelle
 public:
   Com() = default; // ctor
   ~Com(); // dtor
   bool WriteCom(const char *const pszT); // Ausgabe, belegt Schnittstelle
   void ReleaseCom(); // Schnittstelle freigeben
};
// Definition der Memberfunktionen
// Destruktor
Com::~Com()
{
   // Falls Objekt Schnittstelle besitzt, diese wieder freigeben
   if (hasCom)
      comLocked = false;
}
// Auf Schnittstelle schreiben
bool Com::WriteCom(const char *const pszT)
{
   bool retVal = true;
   // Wenn Objekt Schnittstelle besitzt, dann schreiben
   if (hasCom)
      cout << pszT << endl;
   else
   {
      // Falls Schnittstelle nicht belegt ist
      if (!comLocked)
      {
         // Schnittstelle belegen und Objekt besitzt jetzt Schnittstelle
         comLocked = true;
         hasCom = true;
         // Auf Schnittstelle schreiben
         cout << pszT << endl;
      }
      else
      {
         // Anderes Objekt besitzt Schnittstelle
         retVal = false;
      }
   }
   return retVal;
}
// Schnittstelle freigeben
void Com::ReleaseCom()
{
   // Falls Objekt die Schnittstelle besitzt
   if (hasCom)
   {
      // Schnittstelle freigeben
      hasCom = false;
      comLocked = false;
   }
}

// 2 COM-Objekte erstellen
Com ComA;
Com ComB;

// main() Funktion
int main()
{
   // 1. COM-Objekt schreibt auf Schnittstelle
   if (!ComA.WriteCom("1. Schreiben von Objekt A"))
      cout << "Ausgabefehler!" << endl;
   if (!ComA.WriteCom("2. Schreiben von Objekt A"))
      cout << "Ausgabefehler!" << endl;
   // 2. COM-Objekt versucht nun auf Schnittstelle zu schreiben
   if (!ComB.WriteCom("1. Schreiben von Objekt B"))
      cout << "Ausgabefehler!" << endl;
   // 1. COM-Objekt gibt Schnittstelle wieder frei
   cout << "Objekt A gibt Schnittstelle wieder frei\n";
   ComA.ReleaseCom();
   // 2. COM-Objekt kann jetzt auf Schnittstelle schreiben
   if (!ComB.WriteCom("2. Schreiben von Objekt B"))
      cout << "Ausgabefehler!" << endl;
   if (!ComB.WriteCom("3. Schreiben von Objekt B"))
      cout << "Ausgabefehler!" << endl;
}
