#include <iostream>
#include <iomanip>
#include <fstream>
#include <string>
#include <cstdlib>

using std::cout;
using std::endl;

// Konstanten für Dateiname und Anzahl der Buchstaben im Alphabet
const std::string FILENAME = "test.txt";
constexpr auto NUMOFCHARS = 26;

// main() Funktion
int main()
{
   // Datei öffnen
   std::ifstream inFile(FILENAME);
   if (!inFile)
   {
      cout << "Kann Datei " << FILENAME << " nicht öffnen!" << endl;
      exit(1);
   }

   // Zähler für die Anzahl der Buchstaben definieren und initialisieren
   int characters[NUMOFCHARS] {};
   // Zähler für Sonderzeichen wie z.B. '.' oder ',' usw.
   auto specialChar = 0;

   // Schleife zum Einlesen der Datei
   do
   {
      // String für eingelesene Zeile aus der Datei
      std::string line;
      // Eine Zeile aus der Datei einlesen
      // und falls Dateiende nicht erreicht
      if (std::getline(inFile,line); !inFile.eof())
      {
         // Komplette Zeile durchlaufen
         for (auto zeichen: line)
         {
            // Falls Buchstabe im String a...z
            if ((zeichen>='a') && (zeichen<='z'))
               characters[zeichen-'a']++;
            else
               // Falls Buchstabe im String A...Z
               if ((zeichen>='A') && (zeichen<='Z'))
                  characters[zeichen-'A']++;
               else
                  // Sonderzeichen erhöhen
                  specialChar++;
         }
      }
   } while (!inFile.eof());

   // Datei auch wieder schliessen!
   inFile.close();

   // Ergebnis ausgeben
   cout << "Anzahl der Buchstaben in der Datei " << FILENAME << endl;
   // Alle Buchstabenzähler ausgeben
   for (auto index=0; index<NUMOFCHARS; index++)
   {
      // Nach jedem 5. Buchstaben eine neue Zeile beginnen
      if (index%5 == 0)
         cout << endl;
      cout << static_cast<char>(index+'a') << ": " << std::setw(3)
           << characters[index] << '\t';
   }
   // Noch Anzahl der Sonderzeichen ausgeben
   cout << "\nSonderzeichen: " << specialChar << endl;
}
