#include <iostream>
#include <fstream>
#include <string>
#include <cstdlib>
#include <cctype>

using std::cout;
using std::endl;
using namespace std::string_literals; // Suffix s fuer string einblenden

// Ein- und Ausgabedatei
const auto IFILE = "gcc.mak"s;
const auto OFILE = "conv.mak"s;

// main() Funktion
int main()
{
   // string Objekt in dem der gesamte von Kommentaren und Leerzeilen
   // befreite Dateiinhalt von pIFILE abgelegt wird
   std::string resString;

   // Eingabedatei öffnen
   std::ifstream inFile(IFILE);
   if (!inFile)
   {
      cout << "Fehler beim Oeffnen der Datei " << IFILE << endl;
      exit(1);
   }

   // Datei komplett durchlaufen
   do
   {
      // string Objekt für einzelne Zeile aus der Datei
      std::string line;
      // Komplette Zeile einlesen
      // und falls noch nicht Dateiende erreicht
      if (std::getline(inFile,line); !inFile.eof())
      {
         // Wenn Zeile nicht Kommentarzeile und nicht Leerzeile
         if ((line[0] != '#') && (line.size() != 0))
         {
            // Zeile zum neuen Dateiinhalt hinzufügen
            resString += line;
            // Zeilenvorschub nicht vergessen!
            resString += '\n';
         }
      }
   } while (!inFile.eof());
   // Eingabedatei schliessen
   inFile.close();

   // Jetzt alles in Grossbuchstaben wandeln
   for (auto& zeichen: resString)
      zeichen = std::toupper(zeichen);

   // Ausgabedatei öffnen
   std::ofstream outFile(OFILE);
   if (!outFile)
   {
      cout << "Fehler beim Öffnen der Datei " << OFILE << endl;
      exit(1);
   }
   // Neuen Dateiinhalt in Datei übertragen
   outFile << resString;
   // Ausgabedatei schliessen
   outFile.close();
}
