// Dateien einbinden
#include <iostream>
#include "demo.h"

using std::cout;
using std::endl;
using std::ostream;

// Kurzschreibweise fuer unsigned short
using ushort = unsigned short;

// Klassentemplate Definition
// Feldgroesse wird als non-type Parameter uebergeben
template <typename T, int ROWS, int COLS=0>
class Matrix
{
    // Feld anlegen
    // Wenn Spaltenzahl (COLS) Null ist, wird
    // Spaltenzahl gleich Zeilenzahl gesetzt
    T matrix[ROWS][COLS==0?ROWS:COLS];
    // Anzahl der Spalten
    const ushort NOOFCOLS = sizeof(matrix)/sizeof(T)/ROWS;
  public:
    // ctor
    Matrix(T val);
    // Ausgabe des Feldinhalts
    void PrintIt() const;
};

// ctor
template <typename T, int ROWS, int COLS>
Matrix<T, ROWS, COLS>::Matrix(T val)
{
    // Feld mit Initialwert belegen
    for (ushort row=0; row<ROWS; row++)
        for (ushort col=0; col<NOOFCOLS; col++)
            matrix[row][col] = val;
}
// Ausgabefunktion
template <typename T, int ROWS, int COLS>
void Matrix<T, ROWS, COLS>::PrintIt() const
{
    for (ushort row=0; row<ROWS; row++)
    {
        for (ushort col=0; col<NOOFCOLS; col++)
            cout << matrix[row][col] << ", ";
        cout << endl;
    }
}

// main() Funktion
int main()
{
    // int-Feld mit der Groesse 5x5 anlegen
    Matrix<int,5> matrix1(11);
    matrix1.PrintIt();
    // Demo-Feld mit der Groesse 2x3 anlegen
    Matrix<Demo,2,3> matrix2(Demo("Demo"));
    matrix2.PrintIt();
}
