#include <iostream>
#include <cstdlib>

using std::cout;
using std::endl;

// Template-Funktion
// Liefert true zurueck wenn val1<val2
template <typename T>
bool Lesser(T& val1, T& val2)
{
    return val1<val2;
}
// Template-Funktion
// Liefert true zurueck wenn val1>val2
template <typename T>
bool Greater(T& val1, T& val2)
{
    return val1>val2;
}

// Funktion zum Sortieren von int-Daten
// Das Sortierkriterium wird als Template-Funktion uebergeben
template <typename T>
void Sort(int *data, size_t count, bool(*pf)(T&,T&))
{
    // Einfaches sortieren nach Bubble-Sort
    bool changed;
    do
    {
        changed = false;
        for (size_t i=0; i<count-1; i++)
        {
            if (!(*pf)(data[i],data[i+1]))
            {
                std::swap(data[i],data[i+1]);
                changed = true;
            }
        }
    } while (changed);
}

// main() Funktion
int main()
{
    // int-Feld definieren
    constexpr auto SIZE=10;
    int iarray[SIZE];
    // und mit Zufallszahlen belegen und ausgeben
    for (auto& e: iarray)
    {
        e = std::rand()%100;
        cout << e << ',';
    }
    cout << endl;
    // int-Feld sortieren, Sortierkriterium wird ueber
    // Template-Funktion festgelegt
    Sort(iarray, SIZE, Lesser<int>);
    // int-Feld erneut ausgeben
    for (auto e: iarray)
        cout << e << ',';
    cout << endl;
    // Sortierrichtung absteigend
    Sort(iarray, SIZE, Greater<int>);
    // int-Feld erneut ausgeben
    for (auto e: iarray)
        cout << e << ',';
    cout << endl;
}
