#include <iostream>
#include <string>

using std::cout;
using std::endl;

// Allgemeines Template zur Serialisierung
template <typename T>
class Serialize
{
    T value; // Wert
  public:
    // ctor
    Serialize(const T& v): value(v)
    {}
    // Daten ausgeben
    void Transfer()
    {
        T toTransfer = value;       // Wert zwischenspeichern
        cout << std::hex;           // auf hex umstellen
        // Alle Bytes ausgeben
        for (size_t index=0; index<sizeof(T); index++)
        {
            cout << (toTransfer & 0xff) << ',';
            toTransfer >>= 8;
        }
        cout << endl;
    }
};

// Spezielles Template zur Serialisierung eines strings
template <>
class Serialize<std::string>
{
    std::string value; // Wert
  public:
    // ctor
    Serialize(const std::string& v): value(v)
    { }
    // Daten ausgeben
    void Transfer()
    {
        // string zeichenweise durchlaufen und ausgeben
        for (size_t index=0; index<value.length(); index++)
        {
            cout << value[index] << ',';
        }
        cout << endl;
    }
};

// main() Funktion
int main()
{
    Serialize<long> longVar(0x11223344);
    longVar.Transfer();

    Serialize<std::string> stringVar("Ein Text");
    stringVar.Transfer();
}
