#include <iostream>
#include <fstream>
#include <string>

using std::cout;
using std::endl;
using std::string;

// Basisklasse fuer alle Autos
class Car
{
    string manufacturer;        // Hersteller
    string model;               // Typ
public:
    // ctor
    Car(const string& man, const string& mod):
        manufacturer(man), model(mod)
    {
        cout << manufacturer << ' ' << model << " angelegt.\n";
    }
    // dtor
    virtual ~Car()
    {
        cout << manufacturer << ' ' << model << " geloescht.\n";
    }
    // Ausgabe der Daten
    virtual void Print()
    {
        cout << manufacturer << ' ' << model << ' ';
    }
};

// Klasse fuer Auto mit Verbrennungsmotor
class FuelCar: public Car
{
    unsigned short tank;        // Tankinhalt
public:
    // ctor
    FuelCar(const string& man, const string& mod, unsigned short ta):
        Car(man, mod), tank(ta)
    {
        cout << "   mit Verbrennungsmotor\n";
    }
    // dtor, leert den Tank
    ~FuelCar()
    {
        cout << "Entferne Auto mit Verbrennungsmotor\n   ";
    }
    // Ausgabe der Daten
    void Print()
    {
        Car::Print();
        cout << "Tankinhalt: " << tank << " Liter\n";
    }
};

// Klasse fuer Elektroauto
class ECar: public Car
{
    unsigned short battery;     // Batteriekapzitaet
public:
    // ctor
    ECar(const string& man, const string& mod, unsigned short bat):
        Car(man, mod), battery(bat)
    {
        cout << "  mit Elektroantrieb\n";
    }
    // dtor, entlaedt Batterie
    ~ECar()
    {
        cout << "Entfernen Auto mit Elektroantrieb.\n   ";
    }
    // Ausgabe der Daten
    void Print()
    {
        Car::Print();
        cout << "Batterie: " << battery << " Ah\n";
    }
};

// Anzahl der Fahrzeuge
constexpr int NUMCARS = 3;

int main()
{
    // Feld fuer 3 Fahrzeuge anlegen
    Car *theCars[NUMCARS];
    // Nun die Fahrzeuge anlegen und im Feld abspeichern
    theCars[0] = new ECar("VW", "IQ", 444);
    theCars[1] = new FuelCar("Porsche", "911", 90);
    theCars[2] = new ECar("Renault", "ZOE", 333);
    // Ausgabe der Fahrzeugdaten
    cout << "Fahrzeuge:\n";
    for(auto index=0; index<NUMCARS; index++)
        theCars[index]->Print();
    // Fahrzeuge auch wieder aufraeumen
    for (auto index=0; index<NUMCARS; index++)
        delete theCars[index];
}
